#include "boxlist.h"

/******************************************************************************
 		boxlist is a subclass of CList.  It is used for keeping a list of boxes
 		which the user has drawn.  It provides one additional method not found
 		in CList, which is a method to test each box in the list to see if a
 		mouse click ocurred in it.
 
 ******************************************************************************/

/******************************************************************************
 hitbox
 
		Test each box in the list by calling the box's testhit method.  When
		a box's testhit method returns a value of true, returns this box as the
		function result.
 ******************************************************************************/
genericbox *boxlist::hitbox(Point mouseloc)
{
	short i;
	
	for (i = 0; i < numItems; i++) 
	{
		if (((genericbox *) (*items)[i])->testhit(mouseloc))
		{
			// Mouseloc is in this box
			return (genericbox *)((*items)[i]);
		}
	}
	return 0L;
}