#include "colordirector.h"
#include "colorselector.h"
#include <CDesktop.h>
#include "selectorwindow.h"
#include "Global.h"
#include <Palettes.h>
#include <Picker.h>
#include <CFWDesktop.h>

extern CDesktop		*gDesktop;			/* The visible Desktop				*/
colorselector *gcolorselector;
extern CBureaucrat		*gGopher;		/* First in line to get commands	*/

/******************************************************************************
 Icolordirector 
 		Initializes the colordirector object.
 ******************************************************************************/

void colordirector::Icolordirector(CApplication *aSupervisor)
{
	Rect bounds, deeprect;
	GDHandle thedevice;
	
	CDirector::IDirector(aSupervisor);
	
	// Find the screen with the most colors (the deepest device)
	// And put the window on it
	SetRect ( &bounds,  -32767, -32767, 32767, 32767);
	thedevice = GetMaxDevice(&bounds);
	deeprect = (**thedevice).gdRect;
	bounds.left = deeprect.left + 40;
	bounds.top = deeprect.top + 40;
	bounds.bottom = 16*BOXSIZE + bounds.top;
	bounds.right = 16*BOXSIZE + bounds.left;
	
	// Create the selector window
	itsWindow = (CWindow *)new(selectorwindow);
	itsWindow->INewWindow(&bounds, TRUE, 3200, TRUE, TRUE,  gDesktop, this);
	itsWindow->SetActClick(TRUE);		// Process the click that activates it
	
	// Create the selector pane
	gcolorselector = new colorselector;
	gcolorselector->Icolorselector(itsWindow, this, 1, cmdColorSelect, thedevice);
}

/******************************************************************************
 DoCommand {OVERRIDE}

		Execute a command
 ******************************************************************************/

void	colordirector::DoCommand(
	long		theCommand)
{
	CBureaucrat *thesupervisor;
	
	if (theCommand < 0) 
	{
		if (HiShort(-theCommand) == cmdColorSelect) 
		{
			// The color selector palette sent us a color change.  We want to send
			// it to the current document for processing.  We do this by
			// sending the command to the gopher which will send it up to the
			// current document.
			gGopher->DoCommand(theCommand);
		}
	}
	else
	{		
		switch (theCommand) 
		{	
			default:
				inherited::DoCommand(theCommand);
				break;
		}
	}
}

/******************************************************************************
 Suspend {OVERRIDE}

		Following the Human Interface Guidelines, tear-off menus are hidden
		when the application is suspended.  (This is copied from CTearOffMenu.)
 ******************************************************************************/

void	colordirector::Suspend()
{
    if (active) { 
    
        itsWindow->HideSuspend();
        ((CFWDesktop *) gDesktop)->CalcTopFloat();
		active = TRUE;
	}
}
	

/******************************************************************************
 Resume {OVERRIDE}

		Resume by showing the tear-off window if it was visible before
		we were suspended.  (This is copied from CTearOffMenu.)
 ******************************************************************************/

void	colordirector::Resume()
{
    if (active) {
    
        itsWindow->ShowResume();
        ((CFWDesktop *) gDesktop)->CalcTopFloat();
    }
}

