/*****
 * myapp.c
 *
 * Application class for the sample program to illustrate use of the color selector window.
 * Note:  This application does not check for the existence of color quickdraw.  Obviously,
 * you should do this in a real program before calling color routines, but I didn't want to
 * add a lot of extra code.
 *****/

#include "myapp.h"
#include "mydoc.h"
#include <CFWDesktop.h>
#include <CBartender.h>
#include <Commands.h>
#include "colordirector.h"
#include "colorselector.h"

extern	OSType		gSignature;
extern CDesktop		*gDesktop;			/* The visible Desktop				*/
extern CBartender	*gBartender;		/* Manages all menus				*/

extern colorselector *gcolorselector;	// The color selector palette (pane)

/***
 * Imyapp
 *
 *		Initialize the application.  Creates the colordirector object.
 ***/

void myapp::Imyapp(void)

{
	CStarterApp::IStarterApp();		// Call inherited initialization
						
	thecolordirector = new colordirector;
	thecolordirector->Icolordirector(this);
    
}

/***
 * DoCommand
 *
 *		Processes a menu selection.
 ***/
void myapp::DoCommand(long theCommand)

{
	switch (theCommand) 
	{
		case cmdAbout:
			Alert(130, 0L);							// Show the about box
			break;
		case 1025:									// 1025 is the command number assigned
													// to the "Show Color Selector" menu item
			gcolorselector->itsEnclosure->Show();	// Tell the window to show itself
			break;
		default:	
			inherited::DoCommand(theCommand);
			break;
	}
}


/***
 *
 * UpdateMenus 
 *
 *   Enable/Disable appropriate menu items.
 *
***/

 void myapp::UpdateMenus()
 {
  	inherited::UpdateMenus();     /* Enable standard commands */    
  	gBartender->EnableCmd(1025);   /* Enable "Show Color Selector" */

 }

/***
 * CreateDocument
 *
 *	The user chose New from the File menu, so create a new document.
 ***/

void myapp::CreateDocument()

{
	mydoc	*theDocument = NULL;
	
	TRY
	{
		theDocument = new(mydoc);
		theDocument->Imydoc(this, TRUE);
		theDocument->NewFile();
	}
	
	CATCH
	{
		 if (theDocument) theDocument->Dispose();
	}
	ENDTRY;
}

/******************************************************************************
 MakeDesktop
 
		Create the global Desktop object, which is the top level of
		the visual hierarchy. Overrrides the standard method to use a desktop
		which supports floating windows.
 ******************************************************************************/

void	myapp::MakeDesktop()
{
	gDesktop = new(CFWDesktop);			/* Use a floating window Desktop			*/
	((CFWDesktop *)gDesktop)->IFWDesktop(this);
}	
