( File: ATalkEqu.txt )

( Version 2.0 )

( Copyright 1984, 1985, 1986 Apple Computer, Inc. All Rights Reserved )


( AppleTalk Equates - This file defines the low-level equates for the )
( AppleTalk drivers. )

#ifndef _APPLETALK_
	#define _APPLETALK_

	save.VOCAB.state
	ONLY FORTH
	ALSO ASSEMBLER
	ALSO MAC DEFINITIONS

( System global locations used )

$2D8	CONSTANT AbusVars		\ Pointer to the local variables
$2DC	CONSTANT AbusDCE		\ Pointer to the DCE

4	CONSTANT atpLoadedBit	\ Bit number for ATP loaded in PortBUse

( AppleTalk unit numbers )

9	CONSTANT mppUnitNum	\ MPP unit number
10	CONSTANT atpUnitNum	\ ATP unit number


( Name Binding Protocol (NBP) )

$02	CONSTANT NBP		\ DDP protocol type code for NBP

0	CONSTANT nbpControl	\ Control code
0	CONSTANT nbpTCount	\ Tuple count
1	CONSTANT nbpID		\ NBP ID
2	CONSTANT nbpTuple		\ Start of the first tuple

( NBP tuple header offsets: )

0	CONSTANT TupleNet		\ Offset to network no. [word]
2	CONSTANT TupleNode	\ Offset to node ID [byte]
3	CONSTANT TupleSkt		\ Offset to socket number [byte]
4	CONSTANT TupleEnum	\ Offset to enumerator [byte]
5	CONSTANT TupleName	\ Offset to name part of tuple [byte]
5	CONSTANT TupleAddrSz	\ tuple address field size

( NBP control codes - the following define the different types of NBP packets: )

1	CONSTANT BrRq		\ Broadcast request
2	CONSTANT LkUp		\ Lookup request
3	CONSTANT LkUpReply	\ Lookup reply

( NBP miscellaneous )

2	CONSTANT NIS		\ Names Information Socket (NIS) number
15	CONSTANT TupleMax		\ Most tuples in a lookup reply
\ Equals		EQU  '='	\ Wildcard symbol
\ Star			EQU  '*'	\ "This zone" symbol


( Routing Table Maintenance Protocol (RTMP) )

$01	CONSTANT RTMP		\ DDP protocol type code for RTMP

( RTMP header offsets )

0	CONSTANT RTMPNet		\ Offset to network number [word]
2	CONSTANT RTMPIDLen	\ Offset to ID length [byte]
3	CONSTANT RTMPID		\ Offset to start of ID field

( RTMP packets are received at the well-known RTMP listening socket: )

1	CONSTANT RTMPSkt		\ Number of the RTMP socket


( Datagram Delivery Protocol (DDP) )

0	CONSTANT ddpHopCnt	\ Hop count (only used in long header) [byte]
0	CONSTANT ddpLength	\ Packet length (from this word onwards) [word]
2	CONSTANT ddpChecksum	\ Checksum [word]
4	CONSTANT ddpDstNet	\ Destination network no. [word]
6	CONSTANT ddpSrcNet	\ Network of origin [word]
8	CONSTANT ddpDstNode	\ Destination node address [byte]
9	CONSTANT ddpSrcNode	\ Node of origin [byte]
10	CONSTANT ddpDstSkt	\ Destination socket number [byte]
11	CONSTANT ddpSrcSkt	\ Source socket number [byte]
12	CONSTANT ddpType		\ DDP type field [byte]

2	CONSTANT sDDPDstSkt	\ Destination socket number (short header) [byte]
3	CONSTANT sDDPSrcSkt	\ Source socket number (short header) [byte]
4	CONSTANT sDDPType		\ DDP type field (short header) [byte]

13	CONSTANT DDPHSzLong	\ Size of extended DDP header
5	CONSTANT DDPHSzShort	\ Size of short DDP header

$01	CONSTANT ShortDDP		\ LAP type code for DDP (short header)
$02	CONSTANT LongDDP		\ LAP type code for DDP (long header)

( DDP miscellaneous )

$7F	CONSTANT ddpMaxWKS	\ The highest valid well-known socket
586	CONSTANT ddpMaxData	\ Maximum DDP data size
$03FF	CONSTANT ddpLenMask	\ Mask for DDP length


( AppleBus Link Access Protocol (ABLAP) )

0	CONSTANT lapDstAdr	\ Destination node address [byte]
1	CONSTANT lapSrcAdr	\ Source node address [byte]
2	CONSTANT lapType		\ LAP type field [byte]
3	CONSTANT lapHdSz		\ Size of LAP header

( zs returned by ReadPacket and ReadRest routines )

-1	CONSTANT OverrunErr
-2	CONSTANT CRCErr
-3	CONSTANT UnderrunErr
-4	CONSTANT LengthErr

( SCC interrupt priority )

$2600	CONSTANT SCCLockout	\ This value works on both Mac and Lisa


( MPP (control calls to NBP, DDP and ABLAP) )

242	CONSTANT LookupReply	\ This command queued to ourself
243	CONSTANT WriteLAP		\ Write out LAP packet
244	CONSTANT DetachPH		\ Detach LAP protocol handler
245	CONSTANT AttachPH		\ Attach LAP protocol handler
246	CONSTANT WriteDDP		\ Write out DDP packet
247	CONSTANT CloseSkt		\ Close DDP socket
248	CONSTANT OpenSkt		\ Open DDP socket
249	CONSTANT LoadNBP		\ Load NBP command-executing code
249	CONSTANT LastResident	\ Last resident command
250	CONSTANT ConfirmName	\ Confirm name 				|
251	CONSTANT LookupName	\ Look up name on internet		|
252	CONSTANT RemoveName	\ Remove name from Names Table	|_ Swapped
253	CONSTANT RegisterName	\ Register name in Names Table	|	  In
254	CONSTANT KillNBP		\ Kill outstanding NBP request	|
255	CONSTANT UnloadNBP	\ Unload NBP command code		|

242	CONSTANT FirstMPP		\ First MPP command
255	CONSTANT LastMPP		\ Last MPP command

( MPP queue element standard structure:  arguments passed in the CSParam area )

$1C	CONSTANT Socket		\ Offset to socket number (DDP) [byte]
$1D	CONSTANT CheckSumFlag	\ Offset to checksum flag (DDP) [byte]
$1E	CONSTANT Listener		\ Offset to socket listener (DDP) [word]
$10	CONSTANT ArgBlkSz		\ Size of argument block to WriteDDP
$1E	CONSTANT WDSPointer	\ Offset to WDS pointer (DDP & ABLAP) [word]

$1C	CONSTANT ProtType		\ Offset to protocol type code (ABLAP) [byte]
$1E	CONSTANT Handler		\ Offset to protocol handler (ABLAP) [word]

$1C	CONSTANT Interval		\ Retry interval (NBP) [byte]
$1D	CONSTANT NBPCount		\ Retry count (NBP) [byte]
$1E	CONSTANT EntityPtr	\ Entity pointer (NBP)
$1E	CONSTANT NTQElPtr		\ NT queue element ptr (NBP - Register)
$22	CONSTANT ConfirmAddr	\ Address to confirm at (NBP - Confirm)
$26	CONSTANT NewSocket	\ Socket no. if different (NBP - Confirm) [byte]

$22	CONSTANT VerifyFlag	\ Verify name flag (NBP - Register) [byte]

$22	CONSTANT RetBuffPtr	\ Return buffer pointer (NBP - Lookup)
$26	CONSTANT RetBuffSize	\ Return buffer size (NBP - Lookup) [word]
$28	CONSTANT MaxToGet		\ Max no. responses to get (NBP - Lookup) [word]
$2A	CONSTANT NumGotten	\ Number actually gotten (NBP - Lookup) [word]

( Names Table Queue element - the MPP registered names (and associated sockets) )

0	CONSTANT NTLink		\ Link to next element
4	CONSTANT NTTuple		\ Start of tuple for replies
7	CONSTANT NTSocket		\ Socket number of entity [byte]
9	CONSTANT NTEntity		\ Start of entity name within tuple

( Well-known offsets within MPP local variables (as pointed to by AbusVars) )

0	CONSTANT SysLAPAddr	\ This node's LAP address
1	CONSTANT ToRHA		\ Top of RHA
$19	CONSTANT SysABridge	\ Node address of a bridge [byte]
$1A	CONSTANT SysNetNum	\ This node's network number [word]
$1C	CONSTANT VSCCEnable	\ SR value to re-enable SCC interrupts [word]
$1E	CONSTANT ATPVars		\ ATP variable pointer (high byte is flag)
$22	CONSTANT AfterGlobals	\ After the globals

( MPP miscellaneous )
$18	CONSTANT RHASize		\ Size of read header area
6	CONSTANT WDSEntrySz	\ Size of a WDS entry


( AppleTalk Transaction Protocol (ATP) )

$3	CONSTANT ATP		\ ATP type code (in DDP header)

( ATP header )

0	CONSTANT atpControl	\ Control field [byte]
1	CONSTANT atpBitmap	\ Bitmap (requests only) [byte]
1	CONSTANT atpRespNo	\ Response number (responses only) [byte]
2	CONSTANT atpTransID	\ Transaction ID [word]
4	CONSTANT atpUserData	\ Start of user data [long]
8	CONSTANT atpHdSz		\ Size of ATP header

( ATP control field )

$40	CONSTANT atpReqCode	\ Request code after masking
$80	CONSTANT atpRspCode	\ Response code after masking
$C0	CONSTANT atpRelCode	\ Release code after masking
5	CONSTANT atpXOBit		\ Bit number of exactly-once bit
4	CONSTANT atpEOMBit	\ Bit number of End-Of-Message bit
3	CONSTANT atpSTSBit	\ Send Transmission Status bit no.
$3F	CONSTANT FlagMask		\ Mask for just flags
$F8	CONSTANT ControlMask	\ Mask for good control bits

( ATP limits )

8	CONSTANT atpMaxNum	\ Max no. of responses per request
$242	CONSTANT atpMaxData	\ Maximum data size in ATP packet

( ATP contol calls )

249	CONSTANT RelRspCB		\ Release RspCB		|				|
250	CONSTANT CloseATPSkt	\ Close ATP socket	|				|
251	CONSTANT AddResponse	\ Add response code	| Require open skt	|
252	CONSTANT SendResponse	\ Send response code	|				|
253	CONSTANT GetRequest	\ Get request code	|				|
254	CONSTANT OpenATPSkt	\ Open ATP socket
255	CONSTANT SendRequest	\ Send request code
256	CONSTANT RelTCB		\ Release TCB

249	CONSTANT FirstATP		\ First ATP command
256	CONSTANT LastATP		\ Last ATP command
254	CONSTANT FirstNoSkt	\ First not requiring an open socket

( ATP queue element standard structure:  arguments passed in the CSParam area )

$1C	CONSTANT atpSocket	\ Socket number is first parameter [byte]
$1D	CONSTANT atpFlags		\ Flag [byte]
$1E	CONSTANT AddrBlock	\ Start of address block
$22	CONSTANT ReqLength	\ Size of request buffer [word]
$24	CONSTANT ReqPointer	\ Pointer to request buffer or data
$28	CONSTANT BDSPointer	\ Pointer to Buffer Data Structure (BDS)
$2C	CONSTANT GUArea		\ Start of general-use area
$12	CONSTANT UserData		\ User bytes

( ATP bits )

0	CONSTANT SendCHK		\ Bit no. of send-checksum bit in flags
1	CONSTANT tidValid		\ Bit set when TID valid in SendRequest

( SendRequest call interface )

$2C	CONSTANT NumOfBuffs	\ No. of response buffers passed in BDS [byte]
$2D	CONSTANT TimeoutVal	\ Timeout length in seconds [byte]
$2E	CONSTANT NumOfResps	\ Number of responses received [byte]
$2F	CONSTANT RetryCount	\ Maximum number of retries [byte]

$16	CONSTANT ReqTID		\ Request's TID returned here (for RelTCB)
$1C	CONSTANT CurrBitmap	\ Bitmap of responses not yet received [byte]

( GetRequest call interface )

$2C	CONSTANT ATP.Bitmap	\ Offset where bitmap is returned [byte]
$2E	CONSTANT TransID		\ Transaction ID returned here [word]

( SendResponse call interface )

$2D	CONSTANT BDSSize 	

( AddResponse call interface )

$2C	CONSTANT RspNum		\ No. of this response with transaction [byte]

( ATP general )

6	CONSTANT MaxReqs		\ Maximum number of concurrent requests
8	CONSTANT MaxRsps		\ Max number of concurrent XO responses
6	CONSTANT MaxATPSkts	\ Max number of concurrent responding-sockets
30	CONSTANT ReleaseTime	\ Release timer value in seconds

( ATP Buffer Descriptor Structure (BDS) )

0	CONSTANT BDSBuffSz	\ Send: data length	 Receive: buffer length
2	CONSTANT BDSBuffAdr	\ Send: data address	 Receive: buffer address
6	CONSTANT BDSDataSz	\ Send: used internally Receive: data length
8	CONSTANT BDSUserData	\ Send: 4 user bytes	 Receive: 4 user bytes
12	CONSTANT BDSEntrySz	\ Size of a BDS entry

	restore.VOCAB.state
#endif	( AppleTalk definitions )
