push.VOCAB.state
ONLY FORTH
ALSO DEVELOPMENT
ALSO MAC DEFINITIONS

#ifndef _FileMgr_
	#ifdef _MODULES_
		5000 Insert.Name.Space _FileMgr_
	#else
		#define _FileMgr_
	#endif

	#ifndef _MacTypes_
		INCLUDE" MacTypes.h"
	#endif

	#ifndef _QuickDraw_
		INCLUDE" QuickDraw.4th.inc"
	#endif

( finder constants )
8192	CONSTANT fHasBundle
16384	CONSTANT fInvisible
-3		CONSTANT fTrash
-2		CONSTANT fDeskTop
0		CONSTANT fDisk
1		CONSTANT fOnDesk

( ioPosMode values )
0	CONSTANT fsAtMark
1	CONSTANT fsFromStart
2	CONSTANT fsFromLEOF
3	CONSTANT fsFromMark

64	CONSTANT rdVerify

( ioPermssn values )
0	CONSTANT fsCurPerm
1	CONSTANT fsRdPerm
2	CONSTANT fsWrPerm
3	CONSTANT fsRdWrPerm
4	CONSTANT fsRdWrShPerm

( result codes )
-127	CONSTANT fsDSIntErr
-124	CONSTANT volGoneErr
-123	CONSTANT wrgVolTypErr
-122	CONSTANT badMovErr
-121	CONSTANT tmwdoErr
-120	CONSTANT dirNFErr
-61		CONSTANT wrPermErr
-60		CONSTANT badMDBErr
-59		CONSTANT fsRnErr
-58		CONSTANT extFSErr
-57		CONSTANT noMacDskErr
-56		CONSTANT nsDrvErr
-55		CONSTANT volOnLinErr
-54		CONSTANT permErr
-53		CONSTANT volOffLinErr
-52		CONSTANT gfpErr
-51		CONSTANT rfNumErr
-50		CONSTANT paramErr
-49		CONSTANT opWrErr
-48		CONSTANT dupFNErr
-47		CONSTANT fBsyErr
-46		CONSTANT vLckdErr
-45		CONSTANT fLckdErr
-44		CONSTANT wPrErr
-43		CONSTANT fnfErr
-42		CONSTANT tmfoErr
-41		CONSTANT mFulErr
-40		CONSTANT posErr
-39		CONSTANT eofErr
-38		CONSTANT fnOpnErr
-37		CONSTANT bdNamErr
-36		CONSTANT ioErr
-35		CONSTANT nsvErr
-34		CONSTANT dskFulErr
-33		CONSTANT dirFulErr

:RECORD STANDARD_PBHEADER
	qLink		pointer
	qType		short
	ioTrap		short
	ioCmdAddr	pointer
	ioCompletion	pointer
	ioResult	OSErr
	ioNamePtr	pointer
	ioVRefNum	short
;RECORD

:RECORD FInfo
	fdType		OSType
	fdCreator	OSType
	fdFlags		short
	fdLocation	SizeOf( Point )
	fdFldr		short
;RECORD

:RECORD ioParam
	ioHeader	SizeOf( STANDARD_PBHEADER )
	ioRefNum	short
	ioVersNum	char
	ioPermssn	char
	ioMisc		pointer
	ioBuffer	pointer
	ioReqCount	long
	ioActCount	long
	ioPosMode	short
	ioPosOffset	long
;RECORD

( file parameter block )
:RECORD fileParam
	fileHeader		SizeOf( STANDARD_PBHEADER )
	ioFRefNum		short
	ioFVersNum		char
	filler1			char
	ioFDirIndex		short
	ioFlAttrib		char
	ioFlVersNum		char
	ioFlFndrInfo	SizeOf( FInfo )
	ioFlNum			long
	ioFlStBlk		short
	ioFlLgLen		long
	ioFlPyLen		long
	ioFlRStBlk		short
	ioFlRLgLen		long
	ioFlRPyLen		long
	ioFlCrDat		long
	ioFlMdDat		long
;RECORD

( volume parameter block )
:RECORD volumeParam
	volHeader		SizeOf( STANDARD_PBHEADER )
	filler2			long
	ioVolIndex		short
	ioVCrDate		long
	ioVLsBkUp		long
	ioVAtrb			short
	ioVNmFls		short
	ioVDirSt		short
	ioVBlLn			short
	ioVNmAlBlks		short
	ioVAlBlkSiz		long
	ioVClpSiz		long
	ioAlBlSt		short
	ioVNxtFNum		long
	ioVFrBlk		short
;RECORD

( HFS volume parameter block )
:RECORD HvolumeParam
	HvolHeader		SizeOf( STANDARD_PBHEADER )
	Hfiller2		long
	ioHVolIndex		short
	ioHVCrDate		long
	ioVLsMod		long
	ioHVAtrb		short
	ioHVNmFls		short
	ioVBitMap		short
	ioAllocPtr		short
	ioHVNmAlBlks	short
	ioHVAlBlkSiz	long
	ioHVClpSiz		long
	ioHAlBlSt		short
	ioVNxtCNID		long
	ioHVFrBlk		short
	ioVSigWord		short
	ioVDrvInfo		short
	ioVDRefNum		short
	ioVFSID			short
	ioVBkUp			long
	ioVSeqNum		short
	ioVWrCnt		long
	ioVFilCnt		long
	ioVDirCnt		long
	ioVFndrInfo		32
;RECORD

:RECORD FCBPBRec
	fcbHeader		SizeOf( STANDARD_PBHEADER )
	ioFCBRefNum		short
	fcbfiller		short
	ioFCBIndex		long
	ioFCBFlNm		long
	ioFCBFlags		short
	ioFCBStBlk		short
	ioFCBEOF		long
	ioFCBPLen		long
	ioFCBCrPs		long
	ioFCBVRefNum	short
	ioFCBClpSiz		long
	ioFCBParID		long
;RECORD

( volume control block )
:RECORD vcb
	vcbqLink		pointer
	vcbqType		short
	vcbFlags		short
	vcbSigWord		short
	vcbCrDate		long
	vcbLsBkUp		long
	vcbAtrb			short
	vcbNmFls		short
	vcbDirSt		short
	vcbBlLn			short
	vcbNmBlks		short
	vcbAlBlkSiz		long
	vcbClpSiz		long
	vcbAlBlSt		short
	vcbNxtFNum		long
	vcbFreeBks		short
	vcbVN			28		\ volume name
	vcbDrvNum		short
	vcbDRefNum		short
	vcbFSID			short
	vcbVRefNum		short
	vcbMAdr			pointer
	vcbBufAdr		pointer
	vcbMLen			short
	vcbDirIndex		short
	vcbDirBlk		short
;RECORD

:RECORD DrvQEl
	( flags		long )	( at location -4 of the Queue element )
	drvqLink	pointer
	drvqType	short
	dQDrive		short
	dQRefNum	short
	dQFSID		short
	dQDrvSize	short
;RECORD

( low-memory globals )
$210	CONSTANT BootDrive
$308	CONSTANT DrvQHdr
$338	CONSTANT EjectNotify
$34E	CONSTANT FCBSPtr
$352	CONSTANT DefVCBPtr
$356	CONSTANT VCBQHdr
$360	CONSTANT FSQHdr

	#ifdef _MODULES
		_FileMgr_ restore.Name.Space
	#endif

#endif
pop.VOCAB.state