( QuickDraw Equates and record definitions )

push.VOCAB.state
ONLY DEVELOPMENT
ALSO FORTH
ALSO MAC DEFINITIONS

#ifndef	_Quickdraw_
	#ifdef _MODULES_
		5000 Insert.MODULE _QuickDraw_
	#else
		#define _Quickdraw_
	#endif
	
	#ifndef	_MacTypes_
		#include "MacTypes.h"
	#endif

pointer	CONSTANT QDPtr
Handle	CONSTANT QDHandle
Handle	CONSTANT RgnHandle
pointer	CONSTANT RgnPtr
pointer	CONSTANT QDProcsPtr

8		CONSTANT Pattern
32		CONSTANT Bits16[16]

( transfer modes )
0	CONSTANT srcCopy
1	CONSTANT srcOr
2	CONSTANT srcXor
3	CONSTANT srcBic
4	CONSTANT notSrcCopy
5	CONSTANT notSrcOr
6	CONSTANT notSrcXor
7	CONSTANT notSrcBic
8	CONSTANT patCopy
9	CONSTANT patOr
10	CONSTANT patXor
11	CONSTANT patBic
12	CONSTANT notPatCopy
13	CONSTANT notPatOr
14	CONSTANT notPatXor
15	CONSTANT notPatBic

( Standard colors )
33	CONSTANT blackColor
30	CONSTANT whiteColor
205	CONSTANT redColor
341	CONSTANT greenColor
409	CONSTANT blueColor
273	CONSTANT cyanColor
137	CONSTANT magentaColor
69	CONSTANT yellowColor

( standard picture comments )
0	CONSTANT picLParen
1	CONSTANT picRParen

( color mapping )
0	CONSTANT normalBit
1	CONSTANT inverseBit
2	CONSTANT blueBit
3	CONSTANT greenBit
4	CONSTANT redBit
5	CONSTANT blackBit
6	CONSTANT yellowBit
7	CONSTANT magentaBit
8	CONSTANT cyanBit

( Style constants )
1	CONSTANT bold
2	CONSTANT italic
4	CONSTANT underline
8	CONSTANT outline 
16	CONSTANT shadow
32	CONSTANT condense
64	CONSTANT extend

( GrafVerb constants )
0	CONSTANT frame
1	CONSTANT paint
2	CONSTANT erase
3	CONSTANT invert
4	CONSTANT GVfill

:RECORD Point
	vert		short
	horiz		short
;RECORD

:RECORD Cursor
	data	Bits16[16]
	mask	Bits16[16]
	hotSpot	SizeOf( Point )
;RECORD
	
:RECORD Rect
	topleft		0
	top			short
	left		short
	botright	0
	bottom		short
	right		short
;RECORD

:RECORD	FontInfo
	ascent	short
	descent	short
	widMax	short
	leading	short
;RECORD

:RECORD BitMap
	baseAddr		QDPtr
	rowBytes		short
	bitmap.bounds	0
	bounds.top		short
	bounds.left		short
	bounds.bottom	short
	bounds.right	short
;RECORD

:RECORD	PenState
	pnLoc	SizeOf( Point )
	pnSize	SizeOf( Point )
	pnMode	short
	pnPat	Pattern
;RECORD

:RECORD	Polygon
	polySize	short
	polyBBox	SizeOf( Rect )
	polyPoints	0
;RECORD

:RECORD	Region
	rgnSize		short
	rgnBBox		SizeOf( Rect )
	rgnData		0
;RECORD

:RECORD	Picture
	picSize		short
	picFrame	SizeOf( Rect )
	picData		0
;RECORD

:RECORD QDProcs
	textProc		QDPtr
	lineProc		QDPtr
	rectProc		QDPtr
	rRectProc		QDPtr
	ovalProc		QDPtr
	arcProc			QDPtr
	polyProc		QDPtr
	rgnProc			QDPtr
	bitsProc		QDPtr
	commentProc		QDPtr
	txMeasProc		QDPtr
	getPicProc		QDPtr
	putPicProc		QDPtr
;RECORD

:RECORD	GrafPort
	device					short
	portBits				0
	portBits.Bits			pointer
	portBits.rowBytes		short
	portBits.bounds			0
	portBits.bounds.top		short
	portBits.bounds.left	short
	portBits.bounds.bottom	short
	portBits.bounds.right	short
	portRect				0
	portRect.top			short
	portRect.left			short
	portRect.bottom			short
	portRect.right			short
	visRgn		rgnHandle
	clipRgn		rgnHandle
	bkPat		Pattern
	fillPat		Pattern
	pnState		SizeOf( PenState )
	pnVis		short
	txFont		short
	txFace		short
	txMode		short
	txSize		short
	spExtra		long
	fgColor		long
	bkColor		long
	colrBit		short
	patStretch	short
	picSave		QDHandle
	rgnSave		QDHandle
	polySave	QDHandle
	grafProcs	QDProcsPtr
;RECORD

:RECORD	GrafGlobals
	( the following are "private" variables, do not use )
	fontData	22					( -202 )
	playIndex	long				( -180 )
	fontPtr		QDPtr		\ ^FMOutput record ( -176 )
	fontAdj		SizeOf( Point )		( -172 )
	patAlign	SizeOf( Point )		( -168 )
	polyMax		short				( -164 )
	thePoly		QDHandle			( -162 )
	QDSpare0	short		\ unused word ( -158 )
	playPic		Long				( -156, -15A(A5), $-A0(A5) )
	rgnMax		INTEGER				( -152, -156(A5), $-9C(A5) )
	rgnIndex	INTEGER				( -150, -154(A5), $-9A(A5) )
	rgnBuf		QDHandle	\ PointsHandle ( -148, -152(A5), $-98(A5) )
	wideData	10			\ Fake Region  ( -144, -148(A5), $-94(A5) )
	wideMaster	RgnPtr				( -134, -138(A5), $-8A(A5) )
	wideOpen	RgnHandle			( -130, -134(A5), $-86(A5) )
	( end of "private" variables )
	randSeed	long				( -126, -130(A5), $-82(A5) )
	screenBits	SizeOf( BitMap )	( -122, -126(A5), $-7E(A5) )
	arrow		SizeOf( Cursor )	( -108, -112(A5), $-70(A5) )
	dkGray		Pattern				(  -40,  -44(A5), $-2C(A5) )
	ltGray		Pattern				(  -32,  -36(A5), $-24(A5) )
	gray		Pattern				(  -24,  -28(A5), $-1C(A5) )
	black		Pattern				(  -16,  -20(A5), $-14(A5) )
	white		Pattern				(   -8,  -12(A5), $-C(A5)  )
	thePort		QDPtr				(    0,   -4(A5) )
;RECORD

(  low-memory globals  )
$102	CONSTANT ScrVRes
$104	CONSTANT ScrHRes
$106	CONSTANT ScreenRow
$156	CONSTANT RndSeed
$824	CONSTANT ScrnBase
$834	CONSTANT CrsrPin

	#ifdef _MODULES_
		_QuickDraw_ restore.Name.Space
	#endif

#endif
pop.VOCAB.state

