only mac
also forth definitions
also assembler
also development

( The Little Guy:John's Stuff )
( IRIDIUM.SYS:IRIDIUM:SYSTEMS:SYS_TEAM:Network Ops Plan )

#ifndef _FSEQU_
	INCLUDE" IRIDIUM.SYS:IRIDIUM:SYSTEMS:SYS_TEAM:Network Ops Plan:Includes:FSEqu.Txt"
#endif 

#ifndef _SYSEQU_
	INCLUDE" IRIDIUM.SYS:IRIDIUM:SYSTEMS:SYS_TEAM:Network Ops Plan:Includes:SysEqu.Txt"
#endif 

( The Config data has the following structure
	RECORD
		moreMasters			longword
		newDictionarysize	longword
	END
)

ASCII aevt	CONSTANT kCoreEventClass
ASCII oapp	CONSTANT kAEOpenApplication
ASCII odoc	CONSTANT kAEOpenDocuments
ASCII pdoc	CONSTANT kAEPrintDocuments
ASCII quit	CONSTANT kAEQuitApplication

0		CONSTANT noErr
-1701	CONSTANT errAEDescNotFound
-1708	CONSTANT errAEEventNotHandled

( The following patch is for the File Open/Load routine in the
  Code=1 segment.  This makes it compatible with System 7. )

CODE C1FileStart
	\ starting addr is 0029FF76
	BTST	#1,"MACH2.flags"+3(A5)	\ do AppleEvents exist	F76
	BEQ.S	@old.open		\								F7C

	\ we get here when Apple Events exist, so the file information
	\ is a AppParms record in the SFReply buffer
	\
	LEA		$-4DA(A5),A0	\ FSSSpec.VRefNum				F7E
	BRA.S	@new.open		\								F82

@old.open
	MOVE.L	$AEC,A0			\ AppParmsHandle in A0			F84
	MOVEA.L	(A0),A0			\ pointer in A0					F88
@new.open
	TST.W	(A0)			\ test the type of file open	F8A
	[ $6728 W, ]			\ BEQ.S	$28(PC)	branch to file Open		F8C
END-CODE
HEADER C1FileStart.End

HEADER	MACHRSRC.str
	DC.B	9
	DC.B	'MACH.RSRC'

HEADER start.new.Startup
	$6000 W,					\ BRA d(PC)
	0 W,						\ to be filled in later

CODE set.Masters
	MOVE.L	A3,-(A7)			\ save these regs
	MOVE.L	D3,-(A7)
	SUBQ.L	#4,A7				\ space for result
	MOVE.L	#$436E6667,-(A7)	\ 'Cnfg'
	MOVE.W	#128,-(A7)			\ resource ID 128
			_GetResource
	MOVE.L	(A7)+,A3			\ handle -> A3
	MOVE.L	A3,D0				\ put handle in D0
	TST.L	D0					\ test for valid handle
	BEQ.S	@usedefault			\ branch if handle = 0

	\ use the Configuration value for Master pointer blocks
	MOVE.L	(A3),A0				\ get pointer
	MOVE.L	(A0),D3				\ get count of Master pointers calls

	MOVE.L	A3,-(A7)			\ push handle onto stack
			_ReleaseResource	\ get rid of it
			_MaxMem				\ make sure we are as compact as possible
	TST.L	D3					\ test count of master pointers
	BNE.S	@call.MoreMasters

@usedefault
	MOVEQ.L	#8,D3			\ call MoreMasters 8 times

@call.MoreMasters
	SUBQ.L	#1,D3			\ begin the loop
@callit
			_MoreMasters	\ get another 64 master pointers
	DBRA	D3,@callit
	MOVE.L	(A7)+,D3		\ restore registers
	MOVE.L	(A7)+,A3
	RTS
END-CODE

CODE set.StripAddress.mask	( -- )
	MOVE.L	#$A055,-(A6)	\ trap number for _StripAddress
	JSR		TrapAvailable?	\ does it exist
	MOVEQ.L	#-1,D0			\ setup mask
	TST.L	(A6)+			\ test result from TrapAvailable?
	BNE.S	@gen.mask

	MOVE.L	#$00FFFFFF,D0	\ if _StripAddress doesn't exist, then we always
	BRA.S	@save.mask		\ are 24-bit memory

	\ generate mask
@gen.mask
			_StripAddress	\ let _StripAddress modify the mask
@save.mask
	MOVE.L	D0,StripAddress.mask	\ save the mask in the Mach2 global
	RTS
END-CODE

CODE clear.handlers		( clear the Apple Event Handlers after startup )
	[ $6000 W,			\ BRA d(PC)
	  0 W,     ]		( offset to filled in later )
END-CODE

: MyGotRequiredParams ( from Inside Mac, Vol 6, Apple Events chapter )
	{ theAppleEvent | returnedType actualsize myErr -- OSErr }
	theAppleEvent ASCII miss ASCII **** ^ returnedType
	0 0 ^ actualsize
	CALL AEGetAttributePtr	( -- error )
	-> myErr
	myErr errAEDescNotFound =
	IF
		noErr
	ELSE
		myErr noErr =
		IF
			errAEEventNotHandled
		ELSE
			myErr
		THEN
	THEN
	;

CODE open.MACH.RSRC
	CLR.W	-(A7)				\ allocate space for result
	PEA		MACHRSRC.str		\ addr of "MACH.RSRC"
			_OpenResFile		\ Trap #$A997
	MOVE.W	(A7)+,D0			\ put refnum or error in D0
	BGT.S	@b					\ +$4 $2A045C

	MOVEQ.L	#$0,D0				\ result is error so clear D0

@b								\ $002A045C
	MOVE.W	D0,$-148(A5)		\ save ioRefNum of MACH.RSRC
	RTS
END-CODE

CODE DoNew	( data -- )
	( this routine is installed in the IOTASK UserVector by the
	  Application Start Apple Event Handler.)
	ADDQ.L	#4,A6			\ drop the UserData - we don't use it
	CLR.L	144(A4)			\ clear UserVector
	JSR		clear.handlers	\ clear the startup Apple Event Handlers
	MOVEM.L	D5-D7/A2-A3/A7,-(A6)	\ pause the IOTASK to get back to start
	MOVE.L	A6,$8(A4)				\ save the A6 parameter stack
	JSR		COLD		\ finish up the rest of the startup
						\ install dictionary
						\ setup VP
						\ setup new code segment
						\ allocate hash table
						\ create hash table
						\ setup the OPERATOR
	\ now startup the OPERATOR task
	JSR		0(PC)
	[ $-100 $2A0466 $2A03CE - +
	  HERE 2- ' MACHRSRC.str - -
	  HERE 2- W!
	]
	JMP		-2(A4)		\ begin
END-CODE

: (MyHandleOApp)		( theAppleEvent reply -- OSErr )
	( This routine is the Apple Event Open Application Event handler routine )
	{ theAppleEvent reply | myErr -- error }
	theAppleEvent MyGotRequiredParams	( -- error )
	-> myErr
	myErr 0=
	IF
		['] DoNew UserVector !	( set the UserVector to finish the startup )
		1 UserData !			( must have non-zero data here )
		myErr
	ELSE
		( exit to shell )
		CALL ExitToShell
	THEN
	;

AE: MyHandleOApp		( add the task switch code )
	(MyHandleOApp)		( theAppleEvent reply -- OSErr )
	;AE

CODE get.fileType ( theFSSSpec -- OSType )
	LINK	A2,#-122		\ create a ioParam
	LEA		-122(A2),A0		\ get the ioPB
	MOVE.L	A0,-(A6)		\ push it
	MOVE.L	#122,-(A6)		\ size of ioPB
	CLR.L	-(A6)			\ fill with null's
	FILL
	MOVE.L	(A6),A1				\ the FSSpec in A1
	LEA		-122(A2),A0			\ the ioPB in A0
	MOVE.W	(A1),ioVRefNum(A0)	\ store the volume RefNum
	MOVE.L	2(A1),ioDirID(A0)	\ store the directory ID of the file
	MOVE.L	A1,D0				\ addr of FSSpec to D0
	ADDQ.L	#6,D0				\ offset to the filename pointer
	MOVE.L	D0,ioFilename(A0)	\ store the filename pointer
			_HGetFileInfo
	TST.W	D0					\ test the result
	BEQ.S	@getthetype

	MOVEQ.L	#0,D0				\ leave a null result
	BRA.S	@theexit

@getthetype
	MOVE.L	ioFlFndrInfo(A0),D0	\ extract the file type

@theexit
	MOVE.L	D0,(A6)			\ push the file type
	UNLK	A2				\ deallocate the ioPB
	RTS
END-CODE

ASCII WORK CONSTANT MACH2.filetype

: open.WORK.file
	{ work.FSSSpec -- OSErr }
	work.FSSSpec 0 CALL FSpOpenResFile
	;

CODE save.off.FSS	( input.FSS.buffer -- result )
	LINK	A2,#-126		\ space for the FSS and an ioPB
	MOVE.L	(A6)+,$-4(A2)	\ save FSS
	LEA		-126(A2),A0		\ zero out the ioPB
	MOVE.L	A0,-(A6)
	MOVEQ.L	#52,D0
	MOVE.L	D0,-(A6)
	MOVEQ.L	#0,D0
	MOVE.L	D0,-(A6)
	JSR		FILL

	LEA		-126(A2),A0			\ ioPB
	MOVE.L	$-4(A2),A1			\ FSS
	MOVE.W	(A1),ioVRefNum(A0)	\ use vRefNum from FSS to specify volume
			_HGetVInfo			\ get volume info
	TST.W	D0					\ is there an error
	BNE.S	@sFSSexit			\ branch to error handler

	MOVE.W	#$D2D7,D1			\ vSigWord for MFS volumes
	CMP.W	ioVSigWord(A0),D1	\ is this a MFS volume
	BNE.S	@itsHFS				\ go get the Working directory

@FSScopy
	\ do a straight copy from the FSS to the SFReply buffer
	LEA		$-4DA(A5),A0		\ get MACH2 SFReply Buffer
	MOVE.W	(A1),4(A0)			\ move the vRefNum to AppParms
	MOVE.L	A1,D0				\ get addr of FSS
	ADDQ.L	#6,D0				\ offset addr to file name
	MOVE.L	D0,-(A6)			\ push on stack
	ADDA.W	#10,A0				\ offset in SFReply to make it match AppParms struc
	MOVE.L	A0,-(A6)			\ push addr of AppParms filename
	MOVEQ.L	#0,D0
	MOVE.B	6(A1),D0			\ get string count
	ADDQ.L	#1,D0				\ add count byte
	MOVE.L	D0,-(A6)			\ push string count
	CMOVE						\ copy filename to AppParms
	MOVEQ.L	#0,D0
	BEQ.S	@sFSSexit

@itsHFS
	LEA		-126(A2),A0			\ ioPB in A0
	MOVE.W	(A1),ioVRefNum(A0)	\ store volume ref
	MOVE.L	2(A1),ioWDDirID(A0)	\ store file Directory ID
	MOVE.L	#$4D414348,ioWDProcID(A0)	\ 'MACH'
	MOVEQ.L	#1,D0				\ routine selector
			_OpenWD
	TST.W	D0
	BNE.S	@sFSSexit

	MOVE.W	ioVRefNum(A0),(A1)	\ copy WDRefnum to FSS.vRefNum
	BRA.S	@FSScopy

@sFSSexit
	EXT.L	D0
	MOVE.L	D0,-(A6)
	UNLK	A2
	RTS
END-CODE

CODE set.AppParms.message	( message -- )
	MOVE.L	(A6)+,D0			\ get code for either Open or Print
	MOVE.W	D0,$-4DA(A5)		\ store in SFReply buffer used for AppParms
	RTS
END-CODE

CODE DoOpen
	ADDQ.L	#4,A6		\ drop the UserData
	CLR.L	144(A4)		\ clear UserVector
	JSR		clear.handlers
	MOVEM.L	D5-D7/A2-A3/A7,-(A6)	\ pause the IOTASK to get back to start
	MOVE.L	A6,$8(A4)				\ 
	JSR		COLD		\ finish up the rest of the startup
						\ install dictionary
						\ setup VP
						\ setup new code segment
						\ allocate hash table
						\ create hash table
						\ setup the OPERATOR
	\ now startup the OPERATOR task
	JSR		0(PC)
	[ $-14A $2A04E4 $2A03CE - +
	  HERE 2- ' MACHRSRC.str - -
	  HERE 2- W! ]
	MOVEQ.L	#0,D0
	MOVE.W	D0,$3C(A4)		\ clear the FILEID
	JMP		-2(A4)
END-CODE

ASCII ----	CONSTANT keyDirectObject
ASCII list	CONSTANT typeAEList
$66737320	CONSTANT typeFSS

: (MyHandleODoc)
	{ theAppleEvent reply | [ 66 LALLOT ] myFSS [ 4 LALLOT ]  docList 
	                        myErr index itemsInList actualSize 
	                        keywd returnedType
	                        WORK.flag TEXT.flag -- OSErr }

	( get the direct parameter - a descriptor list - and put it into
	  docList )

	theAppleEvent keyDirectObject typeAEList ^ docList
	CALL AEGetParamDesc -> myErr

	myErr noErr =
	IF
		0 -> WORK.flag
		0 -> TEXT.flag
		^ docList ^ itemsInList CALL AECountItems -> myErr
		itemsInList 0
		DO
			^ docList I 1+ typeFSS ^ keywd ^ returnedType ^ myFSS 70 ^ actualSize
			CALL AEGetNthPtr -> myErr
			myErr noErr =
			IF
				^ myFSS get.fileType
				CASE
					MACH2.filetype
					OF
						WORK.flag 0=
						IF I 1+ -> WORK.flag
						THEN
					ENDOF

					ASCII TEXT
					OF
						TEXT.flag 0=
						IF I 1+ -> TEXT.flag
						THEN
					ENDOF
				ENDCASE
			THEN
		LOOP

		WORK.flag 0= NOT
		IF
			^ docList WORK.flag typeFSS 
			^ keywd ^ returnedType ^ myFSS 70 ^ actualSize
			CALL AEGetNthPtr -> myErr
			myErr 0=
			IF
				^ myFSS open.WORK.file -> myErr
			THEN
		THEN

		TEXT.flag 0= NOT
		IF
			^ docList TEXT.flag typeFSS 
			^ keywd ^ returnedType ^ myFSS 70 ^ actualSize
			CALL AEGetNthPtr -> myErr
			myErr 0=
			IF
				( we need to save off this FSS so the Editor can open
				  the file when it starts up. )
				^ myFSS save.off.FSS	( -- result )
				0=
				IF
					0 set.AppParms.message
					['] DoOpen
				ELSE
					['] DoNew
				THEN
			THEN
		ELSE
			['] DoNew
		THEN
		UserVector !
		1 UserData !
		^ docList CALL AEDisposeDesc -> myErr
	ELSE
		( exit to shell, major error )
		CALL ExitToShell
	THEN
	myErr
	;

AE: MyHandleODoc
	(MyHandleODoc)			( theAppleEvent reply -- OSErr )
	;AE

CODE	stash.LFile.refnum
	MOVE.L	(A6)+,D0		\ get the open file refnum
	MOVE.W	D0,$-4D8(A5)	\ store it in the SFReply record that is used for AppParms
	RTS
END-CODE

CODE DoPrint
	ADDQ.L	#4,A6		\ drop the UserData
	CLR.L	144(A4)		\ clear UserVector
	JSR		clear.handlers
	MOVEM.L	D5-D7/A2-A3/A7,-(A6)	\ pause the IOTASK to get back to start
	MOVE.L	A6,$8(A4)				\ 
	JSR		COLD		\ finish up the rest of the startup
						\ install dictionary
						\ setup VP
						\ setup new code segment
						\ allocate hash table
						\ create hash table
						\ setup the OPERATOR
	\ now startup the OPERATOR task
	JSR		0(PC)
	[ $-14A $2A04E4 $2A03CE - +
	  HERE 2- ' MACHRSRC.str - -
	  HERE 2- W! ]
	MOVE.W	$-4D8(A5),$3C(A4)		\ set the FileID
	JMP		-2(A4)
END-CODE

: (MyHandlePDoc)
	{ theAppleEvent reply | [ 66 LALLOT ] myFSS my.action.ptr 
	                        [ 4 LALLOT ]  docList 
	                        myErr index itemsInList
	                        actualSize keywd returnedType
	                        WORK.flag TEXT.flag my.RefNum -- OSErr }

	( get the direct parameter - a descriptor list - and put it into
	  docList )

	theAppleEvent keyDirectObject typeAEList ^ docList
	CALL AEGetParamDesc -> myErr

	myErr noErr =
	IF
		0 -> WORK.flag
		0 -> TEXT.flag
		^ docList ^ itemsInList CALL AECountItems -> myErr
		itemsInList 0
		DO
			^ docList I 1+ typeFSS ^ keywd ^ returnedType ^ myFSS 70 ^ actualSize
			CALL AEGetNthPtr -> myErr
			myErr noErr =
			IF
				^ myFSS get.fileType
				CASE
					MACH2.filetype
					OF
						WORK.flag 0=
						IF I 1+ -> WORK.flag
						THEN
					ENDOF

					ASCII TEXT
					OF
						TEXT.flag 0=
						IF I 1+ -> TEXT.flag
						THEN
					ENDOF
				ENDCASE
			THEN
		LOOP

		WORK.flag 0= NOT
		IF
			^ docList WORK.flag typeFSS 
			^ keywd ^ returnedType ^ myFSS 70 ^ actualSize
			CALL AEGetNthPtr -> myErr
			myErr 0=
			IF
				^ myFSS open.WORK.file -> myErr
			THEN
		THEN

		['] DoNew -> my.action.ptr
		TEXT.flag 0= NOT
		IF
			^ docList TEXT.flag typeFSS 
			^ keywd ^ returnedType ^ myFSS 70 ^ actualSize
			CALL AEGetNthPtr -> myErr
			myErr 0=
			IF
				( we need to open this file and store it in the
				  FILEID of the IOTASK. )
				^ myFSS $0100 ^ my.RefNum CALL FSpOpenDF ( -- OSErr )
				0=
				IF
					1 set.AppParms.message	\ set the AppParms message to Print (Load)
					^ my.RefNum W@ stash.LFile.refnum
					['] DoPrint -> my.action.ptr
				THEN
			THEN
		THEN
		my.action.ptr UserVector !
		1 UserData !
		^ docList CALL AEDisposeDesc -> myErr
	ELSE
		( exit to shell, major error )
		CALL ExitToShell
	THEN
	myErr
	;

AE: MyHandlePDoc
	(MyHandlePDoc)			( theAppleEvent reply -- OSErr )
	;AE

: (clear.handlers)
	kCoreEventClass kAEOpenApplication ['] MyHandleOApp 0
	CALL AERemoveEventHandler DROP

	kCoreEventClass kAEOpenDocuments ['] MyHandleODoc 0
	CALL AERemoveEventHandler DROP

	kCoreEventClass kAEPrintDocuments ['] MyHandlePDoc 0
	CALL AERemoveEventHandler DROP
	;

' (clear.handlers) ' clear.handlers 2+ -	\ offset
' clear.handlers 2+ W!

: (MyHandleQuit)
	{ theAppleEvent reply | userCanceled myErr -- OSErr }
	theAppleEvent MyGotRequiredParams -> myErr
	myErr 0= 
	IF
		['] BYE UserVector !
		1 UserData !
	THEN
	myErr
	;

AE: MyHandleQuit
	(MyHandleQuit)			( theAppleEvent reply -- OSErr )
	;AE

CODE install.default.handlers
	SUBQ.L	#2,A7
	MOVE.L	#kCoreEventClass,-(A7)
	MOVE.L	#kAEOpenApplication,-(A7)
	LEA		MyHandleOApp,A0
	MOVE.L	A0,-(A7)
	MOVE.L	A4,-(A7)
	CLR.W	-(A7)
	MOVE.W	#$091F,D0
			_AEInstallEventHandler
	TST.W	(A7)+
	BEQ.S	@installodoc

			_ExitToShell

@installodoc
	SUBQ.L	#2,A7
	MOVE.L	#kCoreEventClass,-(A7)
	MOVE.L	#kAEOpenDocuments,-(A7)
	LEA		MyHandleODoc,A0
	MOVE.L	A0,-(A7)
	MOVE.L	A4,-(A7)
	CLR.W	-(A7)
	MOVE.W	#$091F,D0
			_AEInstallEventHandler
	TST.W	(A7)+
	BEQ.S	@installpdoc

			_ExitToShell

@installpdoc
	SUBQ.L	#2,A7
	MOVE.L	#kCoreEventClass,-(A7)
	MOVE.L	#kAEPrintDocuments,-(A7)
	LEA		MyHandlePDoc,A0
	MOVE.L	A0,-(A7)
	MOVE.L	A4,-(A7)
	CLR.W	-(A7)
	MOVE.W	#$091F,D0
			_AEInstallEventHandler
	TST.W	(A7)+
	BEQ.S	@installquit

			_ExitToShell

@installquit
	SUBQ.L	#2,A7
	MOVE.L	#kCoreEventClass,-(A7)
	MOVE.L	#kAEQuitApplication,-(A7)
	LEA		MyHandleQuit,A0
	MOVE.L	A0,-(A7)
	MOVE.L	A4,-(A7)
	CLR.W	-(A7)
	MOVE.W	#$091F,D0
			_AEInstallEventHandler
	TST.W	(A7)+
	BEQ.S	@alldone

			_ExitToShell
@alldone
	RTS
END-CODE

CODE init.vars
	MOVEQ.L	#0,D0
	MOVE.L	D0,HLE.Handler
	MOVE.L	D0,MODULE.list
	MOVE.L	D0,MACH2.flags
	RTS
END-CODE

CODE my.startup
	JSR		set.Masters		\ do this first before anything
	MOVE.L	A3,-(A7)		\ save A3
	LINK	A6,#-512		\ setup a FORTH stack
	MOVE.L	A7,A3			\ setup return stack
	MOVE.L	A7,D4			\ setup the TrapStack
	MOVEQ.L	#$40,D0			\ quickly put $40 in D0
	ASL.L	#5,D0			\ make it $800
	SUB.L	D0,D4			\ the trapStack is $800 below the subroutine stack
	BSR.S	init.vars		\ initialize my new global variables
	JSR		set.StripAddress.mask
	JSR		Gestalt.Exist?
	TST.L	(A6)+
	BEQ.S	@call.SysEnvirons

	ORI.L	#1,MACH2.flags
	MOVE.L	#$65766E74,D0	\ 'evnt'
			_Gestalt		\ test for high-level events
	TST.W	D0
	BNE.S	@call.SysEnvirons

	MOVE.L	A0,D0			\ get flags in D0
	BTST	#0,D0			\ is gestaltAppleEventsPresent
	BEQ.S	@call.SysEnvirons

	ORI.L	#2,MACH2.flags	\ set bit 1

@call.SysEnvirons
	JSR		SysEnvirons.Exist?	\ does _SysEnvirons exist?
	TST.L	(A6)+				\ test the result
	BEQ.S	@test.4.WNE			\ result is zero if does not exist

	ORI.L	#4,MACH2.flags		\ set bit 2

@test.4.WNE
	MOVE.L	#$A860,-(A6)		\ does WaitNextEvent exist
	JSR		TrapAvailable?		\ ( -- flag )
	TST.L	(A6)+				\ test for existence
	BEQ.S	@keepon

	ORI.L	#8,MACH2.flags		\ set bit 3

@keepon
	LEA		MACH2.SysEnvRec,A0	\ get the Mach2 SysEnvirons record
	MOVE.L	A0,-(A6)			\ push on stack
	MOVEQ.L	#2,D0				\ version #2
	MOVE.L	D0,-(A6)			\ push on stack
	JSR		"SysEnvirons"
	MOVE.L	(A7)+,D4			\ restore D4
	ADDQ.L	#8,A6				\ drop the record and result

	\ now that we have established the presence of high level
	\ events, perform the proper startup procedure

	UNLK	A6				\ unlink A6 to restore startup state
	MOVE.L	(A7)+,A3		\ restore A3
	MOVE.L	MACH2.flags,D0	\ get the configuration flags
	BTST	#1,D0			\ do Apple Events exist?
	BEQ.S	@old.startup	\ branch if they do

	\ we do a System 7 Startup
	JSR		open.MACH.RSRC	\ open MACH.RSRC resource file

	\ partial cold start
	CLR.W	-(A7)		\ because IOTASK setup expects a word value (ioRefNum )
	JSR		COLD		\ execute the first part of COLD start

	\ we are now on the IOTASK A4, A6, and A7
	\ with the IOTASK in a PAUSE'd state

	JSR		install.default.handlers	\ install Apple Event handlers
	JMP		$-2(A4)						\ start the ioTask operating

@old.startup					\ $002A03E8
	MOVEQ.L	#$0,D4				\ D4 will hold the ioVRefNum
	LEA		$-6BE(A5),A0		\ setup ioPB
	CLR.L	$C(A0)				\ clear ioCompletion
	CLR.L	$12(A0)				\ clear ioNamePtr
			_GetVol				\ Trap #$A014
	TST.W	D0					\ check error code
	BNE.S	@check.for.files	\ +$A $2A0404

	LEA		$-6BE(A5),A0		\ get the ioPB
	MOVE.W	$16(A0),D4			\ put ioVRefNum in D4

@check.for.files				\ $002A0404
	MOVEA.L	$AEC,A2				\ get AppParmsHandle
	MOVEA.L	(A2),A2				\ get AppParms pointer
	TST.W	$2(A2)				\ are there files to open
	BEQ.S	@open.MACHRSRC		\ +$2A $2A0438 - branch if not

\ there are files to open
	CMPI.L	#$54455854,$6(A2)	\ is the first file TEXT
	BEQ.S	@first.text			\ +$54 $2A046C - branch if it is

\ the first file is either WORKSPACE or NEW-SEGMENT
\
	LEA		$-6BE(A5),A0		\ setup ioPB
	CLR.L	$C(A0)				\ clear ioCompletion
	CLR.L	$12(A0)				\ clear ioNamePtr
	MOVE.W	$4(A2),$16(A0)		\ set ioVRefNum to folder refnum
								\ of file to open
			_SetVol				\ Trap #$A015 - set the AppParm ioVRefNum
	CLR.W	-(A7)				\ allocate result
	PEA		$C(A2)				\ push name pointer
			_OpenResFile		\ Trap #$A997 open the resource fork
	MOVE.W	(A7)+,D0			\ refnum or error
\
\ no files to open comes here
@open.MACHRSRC					\ $002A0438
	TST.W	D4					\ is Mach2 refnum non-zero
	BEQ.S	@a					\ +$14 $2A044E - branch if it is

	LEA		$-6BE(A5),A0		\ setup ioPB
	CLR.L	$C(A0)				\ clear ioCompletion
	CLR.L	$12(A0)				\ clear ioNamePtr
	MOVE.W	D4,$16(A0)			\ reset Mach2 ioVRefNum
			_SetVol				\ Trap #$A015

@a								\ $002A044E
	CLR.W	-(A7)				\ allocate space for result
	PEA		MACHRSRC.str		\ addr of "MACH.RSRC"
			_OpenResFile		\ Trap #$A997
	MOVE.W	(A7)+,D0			\ put refnum or error in D0
	BGT.S	@b					\ +$4 $2A045C

	MOVEQ.L	#$0,D0				\ result is error so clear D0

@b								\ $002A045C
	MOVE.W	D0,$-148(A5)		\ save ioRefNum of MACH.RSRC
	JSR		$E0A(A5)			\ <$33B1EC> $2A31BC COLD
	JSR		$-100(PC)			\ $2A0366 setup the OPERATOR
	[ $-100 $2A0466 $2A03CE - +
	  HERE 2- ' MACHRSRC.str - -
	  HERE 2- W! ]

	JMP		$-2(A4)				\ start the round robin
\
\ the first file is TEXT
@first.TEXT						\ $002A046C
	TST.W	D4					\ is ioVRefNum non-zero
	BEQ.S	@openorprint		\ +$14 $2A0482

	LEA		$-6BE(A5),A0		\ setup ioPB
	CLR.L	$C(A0)				\ clear ioCompletion
	CLR.L	$12(A0)				\ clear ioNamePtr
	MOVE.W	D4,$16(A0)			\ set MACH2 ioVRefNum
			_SetVol				\ Trap #$A015

@openorprint
	MOVEQ.L	#$0,D0				\ clear the ioResult
	TST.W	$0(A2)				\ open or print?
	BEQ.S	@openfile			\ +$42 $2A04CA open file if zero

\ it says print, so we will be LOADing the file
	SUBA.L	#$C8,A7				\ create temporary ioPB
	MOVEA.L	A7,A0				\ setup ioPB
	LEA		$C(A2),A1			\ get addr of filename
	MOVE.L	A1,$12(A0)			\ store in ioNamePtr
	MOVE.B	#$1,$1B(A0)			\ open for reading
	MOVE.W	$4(A2),$16(A0)		\ set the ioVRefNum
	CLR.B	$1A(A0)
	CLR.L	$1C(A0)
	CLR.L	$C(A0)
			_Open				\ Trap #$A000
	MOVEA.L	A7,A0				\ restore the ioPB
	TST.W	$10(A0)				\ test the ioResult
	BEQ.S	@get.ioRefNum		\ +$6 $2A04C0 no error

	MOVEQ.L	#$0,D0				\ clear the error
	BRA.S	@dealloc.ioPB		\ +$6 $2A04C4

@get.ioRefNum					\ $002A04C0
	MOVE.W	$18(A0),D0			\ get the ioRefNum

@dealloc.ioPB					\ $002A04C4
	ADDA.L	#$C8,A7				\ de-alloc the ioPB
\ 
\ open file comes here
@openfile						\ $002A04CA
	MOVE.W	D0,-(A7)			\ push the ioRefNum

\ open MACH.RSRC
	CLR.W	-(A7)				\ allocate result
	PEA		MACHRSRC.str		\ string "MACH.RSRC"
			_OpenResFile		\ Trap #$A997
	MOVE.W	(A7)+,D0			\ get ioRefNum
	BGT.S	@the.op.start		\ +$4 $2A04DA - good refnum

	MOVEQ.L	#$0,D0				\ clear ioRefNum - no MACH.RSRC

@the.op.start					\ $002A04DA
	MOVE.W	D0,$-148(A5)		\ store ioRefNum of MACH.RSRC
	JSR		$E0A(A5)			\ <$33B1EC> $2A31BC COLD
	JSR		$-14A(PC)			\ $2A039A setup OPERATOR, file
	[ $-14A $2A04E4 $2A03CE - +
	  HERE 2- ' MACHRSRC.str - -
	  HERE 2- W! ]
	MOVE.W	(A7)+,$3C(A4)		\ store away the ioRefNum to LOAD
	JMP		$-2(A4)				\ start the round-robin
END-CODE

HEADER new.Startup.end

CR .( Finished the new startup code.  Now compiling installer  )

' my.Startup ' start.new.startup 2+ -
' start.new.startup 2+ W!

: patch.CODE1
	{ | resh CODE1.ptr res.refnum @filename }
	ASCII CODE 1 CALL GetResource -> resh
	resh 0= NOT
	IF
		resh CALL HandToHand 0= NOT
		IF
			CR ." Could not duplicate the CODE 1 handle."
			resh CALL DisposHandle DROP
			ABORT
		THEN
		-> resh
		resh CALL GetHandleSize
		[ $2A04EE $2A03D8 - ] LITERAL -
		[ ' new.Startup.end ' start.new.startup - ] LITERAL +
		resh SWAP CALL SetHandleSize 
		0= NOT 
		IF
			CR ." Could not increase CODE 1 to add patch."
			resh CALL DisposHandle
			ABORT
		THEN
		resh CALL HLock DROP
		( copy the new code into the segment )
		resh @ CALL StripAddress -> CODE1.ptr
		['] start.new.startup 
		CODE1.ptr [ $2A03D8 $29E232 - ] LITERAL + 
		[ ' new.Startup.end ' start.new.startup - ] LITERAL 
		CMOVE

		( install the patch for the File Open/Load routine )
		['] C1FileStart
		CODE1.ptr [ $29FF76 $29E232 - ] LITERAL +
		[ ' C1FileStart.end ' C1FileStart - ] LITERAL
		CMOVE

		( the segment is patched, now write it out to a file )
		" New CODE1" -> @filename
		@filename CALL CreateResFile 
		@filename CALL OpenResFile -> res.refnum
		res.refnum -1 =
		IF
			CR ." Could not open the output resource file.  Use BYE."
			resh CALL HUnlock DROP
			resh CALL DisposHandle DROP
			ABORT
		THEN
		res.refnum CALL UseResFile

		( delete any old resource )
		ASCII CODE 1 CALL GetResource 
		DUP 0<
		IF
			CR ." Resource Error while trying to access CODE1 file."
			resh CALL HUnlock DROP
			resh CALL DisposHandle DROP
			ABORT
		THEN
		CALL RmveResource
		res.refnum CALL UpdateResFile

		( add the resource )
		resh ASCII CODE 1 " Startup" CALL AddResource 
		res.refnum CALL UpdateResFile
		res.refnum CALL CloseResFile

		resh CALL HUnlock DROP
		resh CALL DisposHandle DROP
	ELSE
		CR ." Could not get the Code 1 resource."
	THEN
	;

\ _FSEQU_ forget.MODULE
\ _SYSEQU_ forget.MODULE

CR .( execute the word patch.Code1 to write out the new )
CR .( CODE=1 image to the file "New CODE1" )
CR