/*********************************************************
 * BBitMapPane.c
 *
 * SUPERCLASS = CBitMapPane
 *
 * Pane class for BBitMapDoc class.
 *
 *  copyright 1992, KSS Scientific Consultants
 *
 ********************************************************/

#include "BBitMapPane.h"

/********************************************************
 * IBBitMapPane()
 *
 * Initialization method.
 *
 *******************************************************/

void BBitMapPane::IBBitMapPane(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing, SizingOption aVSizing,
							LongRect *aBounds, CBitMap *aBitMap, Boolean makePort)
{
	inherited::IBitMapPane(anEnclosure, aSupervisor, aWidth, aHeight, aHEncl, 
							aVEncl, aHSizing, aVSizing, aBounds, aBitMap, makePort);
}

/*********************************************************
 * InstallBitMap()
 *
 * Install the bitmap in itsBitMap.
 *
 *********************************************************/

void BBitMapPane::InstallBitMap(BitMap *theBitMap)
{
	LongRect	theLongRect;
	
	theLongRect.top = theBitMap->bounds.top;
	theLongRect.left = theBitMap->bounds.left;
	theLongRect.bottom = theBitMap->bounds.bottom;
	theLongRect.right = theBitMap->bounds.right;

	CopyBits(theBitMap, itsBitMap->macBitMap, &theBitMap->bounds, &theBitMap->bounds,
			srcCopy, 0L);
	Prepare();
	itsBitMap->CopyFrom(&theLongRect, &theLongRect, 0L);
}
